using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using Ceras;
using UnityEngine.Events;
using TMPro;
using UnityEngine.SceneManagement;
using System.Linq;

namespace Mod
{
	public class Mod : MonoBehaviour
	{
		public static Map[] Maps;
		public static Map Vol;
		public static Sprite TemplateSprite = ModAPI.LoadSprite("TEMPLATE.png");
		public static string mapname;
		public static MapSelectionMenuBehaviour mapmenu = UnityEngine.Object.FindObjectOfType<MapSelectionMenuBehaviour>();
		public static bool debounce = false;
		public static Sprite Square = ModAPI.LoadSprite("black.png");
		public static Sprite Lava = ModAPI.LoadSprite("Lava.png");
		public static Sprite Acid = ModAPI.LoadSprite("Acid.png");
		public static AudioClip acidhiss = ModAPI.LoadSound("Hiss.wav");
		public static string MapName = "Template";
		public static Sprite CustomSprite4Loaded874935936Loaded225182832 = ModAPI.LoadSprite("CustomSprite4Loaded874935936Loaded225182832.png");
        public static Sprite CustomSprite4Loaded488504768Loaded884210240 = ModAPI.LoadSprite("CustomSprite4Loaded488504768Loaded884210240.png");
        public static Sprite CustomSprite4Loaded507402688Loaded691399232 = ModAPI.LoadSprite("CustomSprite4Loaded507402688Loaded691399232.png");
        public static Sprite CustomSprite4Loaded554483520Loaded6752462 = ModAPI.LoadSprite("CustomSprite4Loaded554483520Loaded6752462.png");
        public static Sprite CustomSprite4Loaded564292096Loaded119911368 = ModAPI.LoadSprite("CustomSprite4Loaded564292096Loaded119911368.png");
        public static Sprite CustomSprite4Loaded765327040Loaded330683456 = ModAPI.LoadSprite("CustomSprite4Loaded765327040Loaded330683456.png");
        public static Sprite CustomSprite4Loaded2123303Loaded388716576 = ModAPI.LoadSprite("CustomSprite4Loaded2123303Loaded388716576.png");
        public static Sprite CustomSprite4Loaded328672480Loaded368936064 = ModAPI.LoadSprite("CustomSprite4Loaded328672480Loaded368936064.png");
        public static Sprite CustomSprite5Loaded515333056Loaded134539264 = ModAPI.LoadSprite("CustomSprite5Loaded515333056Loaded134539264.png");
        public static Sprite CustomSprite6Loaded871119616Loaded54046188 = ModAPI.LoadSprite("CustomSprite6Loaded871119616Loaded54046188.png");
        public static Sprite CustomSprite8Loaded675435456Loaded527164384 = ModAPI.LoadSprite("CustomSprite8Loaded675435456Loaded527164384.png");
        public static Sprite CustomSprite8Loaded835812224Loaded454257408 = ModAPI.LoadSprite("CustomSprite8Loaded835812224Loaded454257408.png");
        public static Sprite CustomSprite8Loaded587584128Loaded266879184 = ModAPI.LoadSprite("CustomSprite8Loaded587584128Loaded266879184.png");
        public static Sprite CustomSprite8Loaded15193124Loaded106838488 = ModAPI.LoadSprite("CustomSprite8Loaded15193124Loaded106838488.png");
        public static Sprite CustomSprite9Loaded263586240Loaded124454568 = ModAPI.LoadSprite("CustomSprite9Loaded263586240Loaded124454568.png");
        public static Sprite CustomSprite10Loaded938728896Loaded683935680 = ModAPI.LoadSprite("CustomSprite10Loaded938728896Loaded683935680.png");
        public static Sprite CustomSprite12Loaded60811676Loaded936310720 = ModAPI.LoadSprite("CustomSprite12Loaded60811676Loaded936310720.png");
        public static Sprite CustomSprite12Loaded280108000Loaded870386176 = ModAPI.LoadSprite("CustomSprite12Loaded280108000Loaded870386176.png");
        public static Sprite CustomSprite13Loaded582971840Loaded902281728 = ModAPI.LoadSprite("CustomSprite13Loaded582971840Loaded902281728.png");
        public static Sprite CustomSprite14Loaded708814336Loaded179747856 = ModAPI.LoadSprite("CustomSprite14Loaded708814336Loaded179747856.png");
        public static Sprite CustomSprite16Loaded710803776Loaded796315136 = ModAPI.LoadSprite("CustomSprite16Loaded710803776Loaded796315136.png");
        public static Sprite CustomSprite17Loaded871399680Loaded872102016 = ModAPI.LoadSprite("CustomSprite17Loaded871399680Loaded872102016.png");
        public static Sprite CustomSprite17Loaded357151872Loaded36629768 = ModAPI.LoadSprite("CustomSprite17Loaded357151872Loaded36629768.png");
        public static Sprite CustomSprite17Loaded639419712Loaded465289536 = ModAPI.LoadSprite("CustomSprite17Loaded639419712Loaded465289536.png");
        public static Sprite CustomSprite17Loaded207117712Loaded417611456 = ModAPI.LoadSprite("CustomSprite17Loaded207117712Loaded417611456.png");
        public static Sprite CustomSprite18Loaded284651424Loaded490187392 = ModAPI.LoadSprite("CustomSprite18Loaded284651424Loaded490187392.png");
        public static Sprite CustomSprite21Loaded298859840Loaded305468256 = ModAPI.LoadSprite("CustomSprite21Loaded298859840Loaded305468256.png");
        public static Sprite CustomSprite21Loaded495536160Loaded506967360 = ModAPI.LoadSprite("CustomSprite21Loaded495536160Loaded506967360.png");
        public static Sprite CustomSprite21Loaded172666064Loaded12183310 = ModAPI.LoadSprite("CustomSprite21Loaded172666064Loaded12183310.png");
        public static Sprite CustomSprite22Loaded266297200Loaded129722680 = ModAPI.LoadSprite("CustomSprite22Loaded266297200Loaded129722680.png");
        public static Sprite CustomSprite23Loaded441649984Loaded431187264 = ModAPI.LoadSprite("CustomSprite23Loaded441649984Loaded431187264.png");
        public static Sprite CustomSprite23Loaded459950528Loaded912422912 = ModAPI.LoadSprite("CustomSprite23Loaded459950528Loaded912422912.png");
        public static Sprite CustomSprite25Loaded460671264Loaded694568384 = ModAPI.LoadSprite("CustomSprite25Loaded460671264Loaded694568384.png");
        public static Sprite CustomSprite2Loaded214022832 = ModAPI.LoadSprite("CustomSprite2Loaded214022832.png");
        public static Sprite CustomSprite2Loaded414592448 = ModAPI.LoadSprite("CustomSprite2Loaded414592448.png");
        public static Sprite CustomSprite2Loaded134622160 = ModAPI.LoadSprite("CustomSprite2Loaded134622160.png");
        public static Sprite CustomSprite2Loaded581966720 = ModAPI.LoadSprite("CustomSprite2Loaded581966720.png");
        public static Sprite CustomSprite2Loaded587299200 = ModAPI.LoadSprite("CustomSprite2Loaded587299200.png");
        public static Sprite CustomSprite2Loaded372947232 = ModAPI.LoadSprite("CustomSprite2Loaded372947232.png");
        public static Sprite CustomSprite2Loaded165554944 = ModAPI.LoadSprite("CustomSprite2Loaded165554944.png");
        public static Sprite CustomSprite2Loaded431501760 = ModAPI.LoadSprite("CustomSprite2Loaded431501760.png");
        public static Sprite CustomSprite2Loaded876868352 = ModAPI.LoadSprite("CustomSprite2Loaded876868352.png");
        public static Sprite CustomSprite2Loaded847185344 = ModAPI.LoadSprite("CustomSprite2Loaded847185344.png");
        public static Sprite CustomSprite2Loaded601103616 = ModAPI.LoadSprite("CustomSprite2Loaded601103616.png");
        public static Sprite CustomSprite2Loaded930592320 = ModAPI.LoadSprite("CustomSprite2Loaded930592320.png");
        public static Sprite CustomSprite2Loaded492880672 = ModAPI.LoadSprite("CustomSprite2Loaded492880672.png");
        public static Sprite CustomSprite2Loaded164581792 = ModAPI.LoadSprite("CustomSprite2Loaded164581792.png");
        public static Sprite CustomSprite2Loaded844801920 = ModAPI.LoadSprite("CustomSprite2Loaded844801920.png");
        public static Sprite CustomSprite2Loaded272886240 = ModAPI.LoadSprite("CustomSprite2Loaded272886240.png");
        public static Sprite CustomSprite2Loaded49493700 = ModAPI.LoadSprite("CustomSprite2Loaded49493700.png");
        public static Sprite CustomSprite2Loaded901786496 = ModAPI.LoadSprite("CustomSprite2Loaded901786496.png");
        public static Sprite CustomSprite2Loaded899901440 = ModAPI.LoadSprite("CustomSprite2Loaded899901440.png");
        public static Sprite CustomSprite2Loaded58921440 = ModAPI.LoadSprite("CustomSprite2Loaded58921440.png");
        public static Sprite CustomSprite2Loaded143108912 = ModAPI.LoadSprite("CustomSprite2Loaded143108912.png");
        public static Sprite CustomSprite2Loaded595938624 = ModAPI.LoadSprite("CustomSprite2Loaded595938624.png");
        public static Sprite CustomSprite2Loaded35730456 = ModAPI.LoadSprite("CustomSprite2Loaded35730456.png");
        public static Sprite CustomSprite12Loaded280108000Loaded682267648 = ModAPI.LoadSprite("CustomSprite12Loaded280108000Loaded682267648.png");
        public static Sprite CustomSprite12Loaded280108000Loaded458665504 = ModAPI.LoadSprite("CustomSprite12Loaded280108000Loaded458665504.png");
        public static Sprite CustomSprite12Loaded280108000Loaded296229312 = ModAPI.LoadSprite("CustomSprite12Loaded280108000Loaded296229312.png");
        public static Sprite CustomSprite13Loaded582971840Loaded531629120 = ModAPI.LoadSprite("CustomSprite13Loaded582971840Loaded531629120.png");
        public static Sprite CustomSprite14Loaded708814336Loaded365905984 = ModAPI.LoadSprite("CustomSprite14Loaded708814336Loaded365905984.png");
        public static Sprite CustomSprite2Loaded311349856 = ModAPI.LoadSprite("CustomSprite2Loaded311349856.png");
        public static Sprite CustomSprite2Loaded490866560 = ModAPI.LoadSprite("CustomSprite2Loaded490866560.png");
        public static Sprite CustomSprite2Loaded794266688 = ModAPI.LoadSprite("CustomSprite2Loaded794266688.png");
        public static Sprite CustomSprite12Loaded280108000Loaded281314656 = ModAPI.LoadSprite("CustomSprite12Loaded280108000Loaded281314656.png");
        public static Sprite CustomSprite12Loaded280108000Loaded41577496 = ModAPI.LoadSprite("CustomSprite12Loaded280108000Loaded41577496.png");
        public static Sprite CustomSprite12Loaded280108000Loaded128229040 = ModAPI.LoadSprite("CustomSprite12Loaded280108000Loaded128229040.png");
        public static Sprite CustomSprite12Loaded280108000Loaded429000640 = ModAPI.LoadSprite("CustomSprite12Loaded280108000Loaded429000640.png");
        public static Sprite CustomSprite13Loaded582971840Loaded296402464 = ModAPI.LoadSprite("CustomSprite13Loaded582971840Loaded296402464.png");
        public static Sprite CustomSprite14Loaded708814336Loaded741111744 = ModAPI.LoadSprite("CustomSprite14Loaded708814336Loaded741111744.png");
        public static Sprite CustomSprite3Loaded813331520 = ModAPI.LoadSprite("CustomSprite3Loaded813331520.png");
        public static Sprite CustomSprite3Loaded88033864 = ModAPI.LoadSprite("CustomSprite3Loaded88033864.png");
        public static Sprite CustomSprite3Loaded219885392 = ModAPI.LoadSprite("CustomSprite3Loaded219885392.png");
        public static Sprite CustomSprite3Loaded917925696 = ModAPI.LoadSprite("CustomSprite3Loaded917925696.png");
        public static Sprite CustomSprite3Loaded481755008 = ModAPI.LoadSprite("CustomSprite3Loaded481755008.png");
        public static Sprite CustomSprite3Loaded797099840 = ModAPI.LoadSprite("CustomSprite3Loaded797099840.png");
        public static Sprite CustomSprite3Loaded420660320 = ModAPI.LoadSprite("CustomSprite3Loaded420660320.png");
        public static Sprite CustomSprite3Loaded763358784 = ModAPI.LoadSprite("CustomSprite3Loaded763358784.png");
        public static Sprite CustomSprite3Loaded76076480 = ModAPI.LoadSprite("CustomSprite3Loaded76076480.png");
        public static Sprite CustomSprite3Loaded255740928 = ModAPI.LoadSprite("CustomSprite3Loaded255740928.png");
        public static Sprite CustomSprite3Loaded649064128 = ModAPI.LoadSprite("CustomSprite3Loaded649064128.png");
        public static Sprite CustomSprite3Loaded894561856 = ModAPI.LoadSprite("CustomSprite3Loaded894561856.png");
        public static Sprite CustomSprite3Loaded759958400 = ModAPI.LoadSprite("CustomSprite3Loaded759958400.png");
        public static Sprite CustomSprite3Loaded559702592 = ModAPI.LoadSprite("CustomSprite3Loaded559702592.png");
        

		public static PhysicalProperties phys = ModAPI.FindPhysicalProperties("Soft");

		public static void CreateMap(MapSelectionMenuBehaviour mapmenuthingy, string name, string desc, Sprite thumb)
		{
			Vol = ScriptableObject.CreateInstance<Map>();
			Vol.name = name;
			mapname = Vol.name;
			Vol.Description = desc;
			Vol.Thumbnail = thumb;
			var baseplate = Resources.Load<Map>("Maps/Default");
			Vol.Prefab = baseplate.Prefab;
			var mapviewbutton = UnityEngine.Object.Instantiate<GameObject>(mapmenuthingy.MapViewPrefab, Vector3.zero, Quaternion.identity, mapmenuthingy.transform);
			mapviewbutton.GetComponent<MapViewBehaviour>().Map = Vol;
			UISoundBehaviour.Refresh();
			phys.Brittleness = 0f;
			phys.Buoyancy = 0f;
			phys.Flammability = 0f;
			phys.MagneticAttractionIntensity = 0f;
			phys.Conducting = false;
			phys.Burnrate = 0f;
			phys.ImpactIntensityMutliplier = 1f;
			phys.HitVolumeMultiplier = 1f;
			phys.BulletSpeedAbsorptionPower = 0f;
			phys.Softness = 0.1f;
			phys.LodgeStrengthMultiplier = 0.1f;
			phys.SharpForceThresholdMultiplier = 1f;
		}

		public static void OnLoad()
		{
			CreateMap(mapmenu, MapName, "Template", TemplateSprite);
			SceneManager.sceneLoaded += OnSceneLoaded;
		}

		public static void OnSceneLoaded(Scene scene, LoadSceneMode mode)
		{
			if (debounce == false)
			{
				debounce = true;
				var obj = new GameObject();
				obj.AddComponent<MapLoadingStuff>();
			}
		}

		public static void CreateGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, string Layer, bool NoCollision)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, Mod.Square);
			NewGameobject.tag = "NoClear";
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.position = Pos;
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			NewGameobject.transform.rotation = Rotation;
			if (NoCollision)
			{
				NewGameobject.GetComponent<Collider2D>().enabled = false;
			}
			NewGameobject.transform.parent = GameObject.Find("Root").transform.parent;
			NewGameobject.AddComponent<Undraggable>();
			NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
			NewGameobject.AddComponent<ContextMenuOptionComponent>();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			physicalBehaviour.Properties = Mod.phys;
			physicalBehaviour.SpawnSpawnParticles = false;
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
			physicalBehaviour.Deletable = false;
			physicalBehaviour.Disintegratable = false;
			///NewGameobject.AddComponent<AudioSource>();
			///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
			NewGameobject.AddComponent<TestDelay>();
		}

		public static void CreateCustomGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision, int order = 1)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
			NewGameobject.tag = "NoClear";
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			NewGameobject.FixColliders();
			if (NoCollision)
			{
				NewGameobject.GetComponent<Collider2D>().enabled = false;
			}
			NewGameobject.transform.parent = GameObject.Find("Root").transform.parent;
			NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
			NewGameobject.AddComponent<Undraggable>();
			NewGameobject.AddComponent<ContextMenuOptionComponent>();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			physicalBehaviour.Properties = Mod.phys;
			physicalBehaviour.SpawnSpawnParticles = false;
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
			physicalBehaviour.Deletable = false;
			physicalBehaviour.Disintegratable = false;
			physicalBehaviour.rigidbody = NewGameobject.GetComponent<Rigidbody2D>();
			///NewGameobject.AddComponent<AudioSource>();
			///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
			NewGameobject.AddComponent<TestDelay>();
		}

		public static void CreatePhysicsGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Objects");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			NewGameobject.FixColliders(); 
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			if (NoCollision)
			{
				NewGameobject.GetComponent<Collider2D>().enabled = false;
			}
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
		}

		public static void CreateLightSources(String Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Color32 color, float brightness)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			var light = ModAPI.CreateLight(NewGameobject.transform, color, brightness);
			light.gameObject.tag = "NoClear";
		}

		public static void CreateBackground(String Name, Color32 color, Sprite spritey, bool IsTexture)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = new Vector2(572.314f, 496.2918f);
			var whitespace = Texture2D.whiteTexture;
			whitespace.Resize(16, 16);
			whitespace.Apply();
			if (IsTexture == true)
			{
				var croppedTexture = new Texture2D((int)spritey.rect.width, (int)spritey.rect.height);
				var pixels = spritey.texture.GetPixels((int)spritey.textureRect.x,
														(int)spritey.textureRect.y,
														(int)spritey.textureRect.width,
														(int)spritey.textureRect.height);
				croppedTexture.SetPixels(pixels);
				croppedTexture.wrapMode = TextureWrapMode.Repeat;
				croppedTexture.filterMode = FilterMode.Point;
				croppedTexture.Apply();
				var copy = Sprite.Create(croppedTexture, new Rect(0f, 0f, (float)croppedTexture.width, (float)croppedTexture.height), 0.5f * Vector2.one, 140f, 0, SpriteMeshType.FullRect);
				NewGameobject.AddComponent<SpriteRenderer>().drawMode = SpriteDrawMode.Tiled;
				NewGameobject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
				NewGameobject.GetComponent<SpriteRenderer>().sprite = copy;
				NewGameobject.GetComponent<SpriteRenderer>().size = new Vector2(5, 5);
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Bottom");
				///NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = 25;
			}
			else
			{
				NewGameobject.AddComponent<SpriteRenderer>().sprite = Sprite.Create(whitespace, new Rect(0f, 0f, 16f, 16f), 0.5f * Vector2.one, 35f);
				NewGameobject.GetComponent<SpriteRenderer>().color = color;
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Bottom");
				///NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = 25;
			}
			NewGameobject.transform.localScale = new Vector2(2533.112f, 2175.462f);
			NewGameobject.transform.parent = GameObject.Find("Root").transform.parent;
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
		}

		public static void CreateParticleSources(string Name, Vector2 Pos, float Speed, string Particles)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.name = Name;
			NewGameobject.transform.position = Pos;
			NewGameobject.AddComponent<ParticleDelay>();
			NewGameobject.GetComponent<ParticleDelay>().Speed1 = Speed;
			NewGameobject.GetComponent<ParticleDelay>().Particles1 = Particles;
		}

		public static void AddAudioToAmbience(float Bacon, AudioClip[] Eggs)
		{
			///Changing this to other variables in the MapConfig will let you force snow on and other stuff.
			MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();
			///mapconfig.OverrideAmbientSounds = true;
			var hhh = mapconfig.transform.parent.GetComponent<PlayAudioAtRandom>();
			hhh.Clips = Eggs;
			hhh.ChancePerSecond = Bacon;
		}

		public static void CreateWaterBlock(Vector3 Size, Vector3 Pos, Quaternion Rotation, string Type)
		{
			Map eggs = Resources.Load<Map>("Maps/Sea");
			GameObject WaterBefore = eggs.Prefab.transform.Find("Root/Sea").gameObject;
			var Water = Instantiate<GameObject>(WaterBefore, Vector3.zero, Quaternion.identity);
			Water.transform.rotation = Rotation;
			Water.transform.localScale = new Vector2(Size.x, -Size.y);
			///Water.transform.SetParent(GameObject.Find("Root").transform);
			Water.transform.localPosition = Pos;
			Water.AddComponent<WaterBlockBehaviour>().GlobalTop = Water.GetComponent<SpriteRenderer>().bounds.max.y;
			Water.GetComponent<WaterBlockBehaviour>().GlobalBottom = Water.GetComponent<SpriteRenderer>().bounds.min.y;
			Water.GetComponent<WaterBlockBehaviour>().GlobalLeft = Water.GetComponent<SpriteRenderer>().bounds.min.x;
			Water.GetComponent<WaterBlockBehaviour>().GlobalRight = Water.GetComponent<SpriteRenderer>().bounds.max.x;
			Water.GetComponent<WaterBlockBehaviour>().WaterSize = Size;
			Water.GetComponent<WaterBlockBehaviour>().WaterCenter = Pos;
			Water.GetComponent<WaterBlockBehaviour>().Drag = Water.GetComponent<WaterBehaviour>().Drag;
			Water.GetComponent<WaterBlockBehaviour>().Buoyancy = Water.GetComponent<WaterBehaviour>().Buoyancy;
			Water.GetComponent<WaterBlockBehaviour>().Trigger = Water.GetComponent<WaterBehaviour>().Trigger;
			Water.GetComponent<WaterBlockBehaviour>().Splash = UnityEngine.Object.Instantiate<GameObject>(Water.GetComponent<WaterBehaviour>().Splash);
			Water.GetComponent<WaterBlockBehaviour>().Splash.SetActive(false);
			Water.GetComponent<WaterBehaviour>().enabled = false;
			WaterBlockBehaviour.Instance = Water.GetComponent<WaterBlockBehaviour>();
			var main = Water.GetComponentInChildren<ParticleSystem>().main;
			var shape = Water.GetComponentInChildren<ParticleSystem>().shape;
			var emission = Water.GetComponentInChildren<ParticleSystem>().emission;
			main.scalingMode = ParticleSystemScalingMode.Shape;
			shape.scale = Size;
			shape.rotation = Water.transform.eulerAngles;
			emission.rateOverTimeMultiplier = 1f * (Size.x / 4.8f);
			if (Type == "Lava")
			{
				Water.GetComponent<SpriteRenderer>().drawMode = SpriteDrawMode.Tiled;
				Water.GetComponent<SpriteRenderer>().tileMode = SpriteTileMode.Continuous;
				Water.GetComponent<SpriteRenderer>().sprite = Mod.Lava;
				Water.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
				var light = ModAPI.CreateLight(Water.transform, new Color32(255, 129, 32, 255), 15, 5);
				Water.AddComponent<LavaBurn>();
				foreach (var particle in Water.GetComponent<WaterBlockBehaviour>().Splash.GetComponentsInChildren<ParticleSystem>())
                {
					var shape2 = particle.shape;
					var main2 = particle.main;
					shape2.texture = Mod.Lava.texture;
					main2.startColor = new Color(1f, 0.5f, 0.12f, 1f);
				}
				Water.GetComponent<WaterBlockBehaviour>().Buoyancy = 0f;
				Water.GetComponent<WaterBlockBehaviour>().Drag += 0.6f;
			}
			else if (Type == "Acid")
			{
				Water.GetComponent<SpriteRenderer>().color = new Color(0, 1, 0, 1);
				Water.GetComponent<SpriteRenderer>().drawMode = SpriteDrawMode.Tiled;
				Water.GetComponent<SpriteRenderer>().tileMode = SpriteTileMode.Continuous;
				Water.GetComponent<SpriteRenderer>().sprite = Mod.Acid;
				Water.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
				var AcidLight = ModAPI.CreateLight(Water.transform, new Color(0, 1, 0, 1), 4, 3);
				Water.AddComponent<AcidBurn>();
				foreach (var particle in Water.GetComponent<WaterBlockBehaviour>().Splash.GetComponentsInChildren<ParticleSystem>())
				{
					var shape2 = particle.shape;
					var main2 = particle.main;
					shape2.texture = Mod.Acid.texture;
					main2.startColor = new Color(0, 1, 0, 0.8f);
				}
				Water.GetComponent<WaterBlockBehaviour>().Buoyancy -= 0.1f;
				Water.GetComponent<WaterBlockBehaviour>().Drag += 0.4f;
			}
			GameObject.Destroy(Water.GetComponent<WaterBehaviour>());
		}

		public static void Main()
		{
			///Don't do anything yet.
			if (MapLoaderBehaviour.CurrentMap == Vol)
            {
				Debug.Log("Setting up some stuff.");
				CreateWaterBlock(new Vector3(-1158.8f, 191.2f, 1f), new Vector3(571.8238f, 94.76822f, 0f), Quaternion.Euler(0f, 0f, 0f), "Acid");
                CreateCustomGameObjects("Custom", new Vector2(492f, 306f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4Loaded874935936Loaded225182832, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(528f, 306f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4Loaded488504768Loaded884210240, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(744f, 306f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4Loaded507402688Loaded691399232, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(708f, 306f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4Loaded554483520Loaded6752462, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(672f, 306f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4Loaded564292096Loaded119911368, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(564f, 306f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4Loaded765327040Loaded330683456, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(600f, 306f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4Loaded2123303Loaded388716576, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(636f, 306f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4Loaded328672480Loaded368936064, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(780f, 306f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite5Loaded515333056Loaded134539264, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(456f, 306f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6Loaded871119616Loaded54046188, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(600f, 438f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8Loaded675435456Loaded527164384, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(636f, 438f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8Loaded835812224Loaded454257408, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(564f, 438f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8Loaded587584128Loaded266879184, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(672f, 438f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8Loaded15193124Loaded106838488, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(708f, 438f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite9Loaded263586240Loaded124454568, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(528f, 438f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite10Loaded938728896Loaded683935680, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(600f, 570f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite12Loaded60811676Loaded936310720, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(636f, 570f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite12Loaded280108000Loaded870386176, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(672f, 570f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13Loaded582971840Loaded902281728, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(564f, 570f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14Loaded708814336Loaded179747856, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(324f, 402f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite16Loaded710803776Loaded796315136, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(288f, 402f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17Loaded871399680Loaded872102016, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(252f, 402f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17Loaded357151872Loaded36629768, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(216f, 402f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17Loaded639419712Loaded465289536, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(180f, 402f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite17Loaded207117712Loaded417611456, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(144f, 402f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite18Loaded284651424Loaded490187392, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(330f, 687f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite21Loaded298859840Loaded305468256, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(366f, 687f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite21Loaded495536160Loaded506967360, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(294f, 687f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite21Loaded172666064Loaded12183310, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(402f, 687f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite22Loaded266297200Loaded129722680, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(258f, 687f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite23Loaded441649984Loaded431187264, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(312f, 651f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite23Loaded459950528Loaded912422912, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(348f, 651f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite25Loaded460671264Loaded694568384, "Front", false);
                CreateLightSources("Light", new Vector2(569.9852f, 477.4131f), new Vector2(0.5f, 0.5f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255, 255, 255), 1f);
                CreateWaterBlock(new Vector3(-1158.8f, 191.2f, 1f), new Vector3(573.03f, 897.3658f, 0f), Quaternion.Euler(0f, 0f, 180f), "Acid");
                CreateCustomGameObjects("Custom", new Vector2(234f, 336f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded214022832, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(234f, 240f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded414592448, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(234f, 144f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded134622160, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(234f, 48f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded581966720, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(330f, 849f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded587299200, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(330f, 945f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded372947232, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(330f, 753f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded165554944, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(594f, 504f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded431501760, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(642f, 504f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded876868352, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(642f, 372f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded847185344, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(594f, 372f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded601103616, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(594f, 240f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded930592320, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(642f, 240f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded492880672, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(642f, 144f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded164581792, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(594f, 144f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded844801920, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(642f, 48f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded272886240, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(594f, 48f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded49493700, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(618f, 240f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded901786496, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(618f, 144f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded899901440, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(618f, 48f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded58921440, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(894f, 945f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded143108912, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(894f, 849f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded595938624, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(894f, 753f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded35730456, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(930f, 591f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite12Loaded280108000Loaded682267648, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(894f, 591f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite12Loaded280108000Loaded458665504, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(858f, 591f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite12Loaded280108000Loaded296229312, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(966f, 591f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13Loaded582971840Loaded531629120, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(822f, 591f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14Loaded708814336Loaded365905984, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(894f, 657f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded311349856, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(876f, 525f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded490866560, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(915f, 525f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2Loaded794266688, "Back", false);
                CreateCustomGameObjects("Custom", new Vector2(876f, 459f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite12Loaded280108000Loaded281314656, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(912f, 459f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite12Loaded280108000Loaded41577496, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(840f, 459f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite12Loaded280108000Loaded128229040, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(948f, 459f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite12Loaded280108000Loaded429000640, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(984f, 459f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite13Loaded582971840Loaded296402464, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(804f, 459f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite14Loaded708814336Loaded741111744, "Front", false);
                CreateWaterBlock(new Vector3(-46.8f, 99.2f, 1f), new Vector3(617.2145f, 370.9311f, 0f), Quaternion.Euler(0f, 0f, 0f), "Acid");
                CreateWaterBlock(new Vector3(-46.8f, 99.2f, 1f), new Vector3(618f, 504f, 0f), Quaternion.Euler(0f, 0f, 0f), "Acid");
                CreateWaterBlock(new Vector3(-36.3f, 99.2f, 1f), new Vector3(895.4446f, 526.2917f, 0f), Quaternion.Euler(0f, 0f, 0f), "Acid");
                CreateCustomGameObjects("Custom", new Vector2(245.7f, 363f), new Vector2(-4.5f, 7f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3Loaded813331520, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(225.6f, 358.5f), new Vector2(4.5f, 8.5f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3Loaded88033864, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(654f, 261f), new Vector2(-5.5f, 9f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3Loaded219885392, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(579.6f, 264f), new Vector2(6.5f, 8f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3Loaded917925696, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(591.6f, 249.9f), new Vector2(-5f, 12.5f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3Loaded481755008, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(606.9f, 264f), new Vector2(6f, 8f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3Loaded797099840, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(632.4f, 255f), new Vector2(-5.5f, 11f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3Loaded420660320, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(285f, 660f), new Vector2(3.5f, 3f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3Loaded763358784, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(369.9f, 652.5f), new Vector2(-2f, 5.5f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3Loaded76076480, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(376.5f, 657f), new Vector2(3f, 4f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3Loaded255740928, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(330f, 738f), new Vector2(-5f, -11f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3Loaded649064128, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(330f, 726f), new Vector2(3.5f, -7f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3Loaded894561856, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(893.4f, 654f), new Vector2(-5f, -15f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3Loaded759958400, "Front", false);
                CreateCustomGameObjects("Custom", new Vector2(234f, 348f), new Vector2(4.5f, 12f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3Loaded559702592, "Front", false);
                CreateBackground("Background", new Color32(155, 155, 155, 255), null, false);
                
			}
		}
	}

	public class MapLoadingStuff : MonoBehaviour
    {
		public void Awake()
        {
			StartCoroutine(Delay());
		}

		public IEnumerator Delay()
        {
			MapSelectionMenuBehaviour ingamemapmenu = UnityEngine.Object.FindObjectOfType<MapSelectionMenuBehaviour>();
			yield return new WaitForSeconds(0f);
			Mod.CreateMap(ingamemapmenu, Mod.mapname, "Template", Mod.TemplateSprite);
			Mod.debounce = false;
		}
    }

	public class TestDelay : MonoBehaviour
	{
		public void Awake()
		{
			StartCoroutine(Delay());
		}

		public IEnumerator Delay()
		{
			yield return new WaitForSeconds(0f);
			this.gameObject.GetComponent<Rigidbody2D>().bodyType = RigidbodyType2D.Static;
		}
	}

	public class ParticleDelay : MonoBehaviour
    {
		public string Particles1;
		public float Speed1;
		public void Awake()
        {
			StartCoroutine(Emit());
		}

		public IEnumerator Emit()
		{
			yield return new WaitForSeconds(0.25f);
			while (true)
			{
				var time = 1f / Speed1;
				ModAPI.CreateParticleEffect(Particles1.ToString(), gameObject.transform.position);
				yield return new WaitForSeconds(time);
			}
		}
    }

	public class LavaBurn : MonoBehaviour
    {
		private void FixedUpdate()
		{
			foreach (PhysicalBehaviour physicalBehaviour in Global.main.PhysicalObjectsInWorld)
			{
				if (!physicalBehaviour)
				{
					break;
				}
				foreach (Vector2 v in physicalBehaviour.LocalColliderGridPoints)
				{
					Vector3 vector = physicalBehaviour.transform.TransformPoint(v);
					if (vector.y <= gameObject.GetComponent<WaterBlockBehaviour>().GlobalTop && vector.y >= gameObject.GetComponent<WaterBlockBehaviour>().GlobalBottom && vector.x >= gameObject.GetComponent<WaterBlockBehaviour>().GlobalLeft && vector.x <= gameObject.GetComponent<WaterBlockBehaviour>().GlobalRight)
					{
						if (physicalBehaviour.BurnProgress < 0.95f)
						{
							if (physicalBehaviour.Properties.Flammability > 0.1f)
                            {
								physicalBehaviour.BurnProgress += 0.01f;
								physicalBehaviour.Ignite();
								physicalBehaviour.burnIntensity = 2f;
							}
							if (physicalBehaviour.gameObject.GetComponent<LimbBehaviour>())
                            {
								physicalBehaviour.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().AddPain(5f);
							}
						}
					}
				}
			}
		}
	}

	public class AcidBurn : MonoBehaviour
	{
		public float a = 1;
		public float b = 1;
		public Color ACIDCOLOR = new Color(1,1,1,1);

		private void FixedUpdate()
		{
			foreach (PhysicalBehaviour physicalBehaviour in Global.main.PhysicalObjectsInWorld)
			{
				if (!physicalBehaviour)
				{
					break;
				}
				foreach (Vector2 v in physicalBehaviour.LocalColliderGridPoints)
				{
					Vector3 vector = physicalBehaviour.transform.TransformPoint(v);
					if (vector.y <= gameObject.GetComponent<WaterBlockBehaviour>().GlobalTop && vector.y >= gameObject.GetComponent<WaterBlockBehaviour>().GlobalBottom && vector.x >= gameObject.GetComponent<WaterBlockBehaviour>().GlobalLeft && vector.x <= gameObject.GetComponent<WaterBlockBehaviour>().GlobalRight)
					{
						if (physicalBehaviour.gameObject.GetComponent<LimbBehaviour>() != null && !physicalBehaviour.isDisintegrated)
						{
							float random = UnityEngine.Random.Range(1f, 10f);
							var limb = physicalBehaviour.gameObject.GetComponent<LimbBehaviour>();
							var skin = physicalBehaviour.gameObject.GetComponent<SkinMaterialHandler>();
							if (physicalBehaviour.gameObject.name == "Head" || physicalBehaviour.gameObject.name == "Foot" || physicalBehaviour.gameObject.name == "FootFront")
                            {
								limb.SkinMaterialHandler.AcidProgress += Time.deltaTime * 0.025f;
								limb.SkinMaterialHandler.RottenProgress += Time.deltaTime * 0.025f;
							}
                            else
                            {
								limb.SkinMaterialHandler.AcidProgress += Time.deltaTime * 0.005f;
								limb.SkinMaterialHandler.RottenProgress += Time.deltaTime * 0.005f;
							}
							limb.Wince(limb.SkinMaterialHandler.AcidProgress * 100f);
							if (limb.SkinMaterialHandler.AcidProgress > 0.75f)
							{
								limb.BreakBone();
								limb.Health = 0f;
							}
							physicalBehaviour.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().AddPain(10f);
							if (limb.Person.OxygenLevel <= 0.7f && !physicalBehaviour.isDisintegrated && physicalBehaviour.gameObject.name != "Head")
							{
								if (limb.Health <= 0f)
								{
									if (skin.RottenProgress >= 0.7f)
									{
										if (skin.AcidProgress >= 0.9f)
										{
											if (physicalBehaviour.gameObject.transform.lossyScale.x < 0f && physicalBehaviour.gameObject.GetComponent<LimbBehaviour>() == null)
											{
												physicalBehaviour.gameObject.transform.localScale = new Vector2(Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.x + 0.005f, -500000f, 0f), Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.y - 0.005f, 0f, 5000000f));
												if (physicalBehaviour.gameObject.transform.localScale.x == 0 && physicalBehaviour.gameObject.transform.localScale.y == 0)
												{
													AudioSource.PlayClipAtPoint(Mod.acidhiss, physicalBehaviour.gameObject.transform.position, 6f);
													physicalBehaviour.Disintegrate();
													break;
												}
											}
											else
											{
												physicalBehaviour.gameObject.transform.localScale = new Vector2(Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.x - 0.005f, 0, 5000000f), Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.y - 0.005f, 0f, 5000000f));
												if (physicalBehaviour.gameObject.transform.localScale.x == 0 && physicalBehaviour.gameObject.transform.localScale.y == 0)
												{
													AudioSource.PlayClipAtPoint(Mod.acidhiss, physicalBehaviour.gameObject.gameObject.transform.position, 6f);
													physicalBehaviour.Disintegrate();
													break;
												}
											}
										}
									}
								}
							}
						}
						else if (physicalBehaviour.Properties.Flammability > 0.1f && !physicalBehaviour.isDisintegrated)
                        {
							if (physicalBehaviour.gameObject.transform.lossyScale.x < 0f && physicalBehaviour.gameObject.GetComponent<LimbBehaviour>() == null)
							{
								physicalBehaviour.gameObject.transform.localScale = new Vector2(Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.x + 0.0005f, -500000f, 0f), Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.y - 0.0005f, 0f, 5000000f));
								if (physicalBehaviour.gameObject.transform.localScale.x == 0 && physicalBehaviour.gameObject.transform.localScale.y == 0)
								{
									AudioSource.PlayClipAtPoint(Mod.acidhiss, physicalBehaviour.gameObject.transform.position, 6f);
									physicalBehaviour.Disintegrate();
									a = 1;
									b = 1;
									break;
								}
							}
							else
							{
								physicalBehaviour.gameObject.transform.localScale = new Vector2(Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.x - 0.0005f, 0, 5000000f), Mathf.Clamp(physicalBehaviour.gameObject.transform.localScale.y - 0.0005f, 0f, 5000000f));
								if (physicalBehaviour.gameObject.transform.localScale.x == 0 && physicalBehaviour.gameObject.transform.localScale.y == 0)
								{
									AudioSource.PlayClipAtPoint(Mod.acidhiss, physicalBehaviour.gameObject.gameObject.transform.position, 6f);
									physicalBehaviour.Disintegrate();
									a = 1;
									b = 1;
									break;
								}
							}
						}
					}
				}
			}
		}
	}

	public class WaterBlockBehaviour : MonoBehaviour ///WaterBehaviour but with more than just the GlobalTop
	{
		private void Awake()
		{
			if (base.gameObject.activeInHierarchy)
			{
				WaterBlockBehaviour.Instance = this;
			}
		}
		private void Start()
		{
			if (base.gameObject.activeInHierarchy)
			{
				WaterBlockBehaviour.Instance = this;
			}
		}
		public static bool IsPointUnderWater(Vector3 pos)
		{
			return WaterBlockBehaviour.Instance && pos.y < WaterBlockBehaviour.Instance.GlobalTop && pos.y > WaterBlockBehaviour.Instance.GlobalBottom && pos.x > WaterBlockBehaviour.Instance.GlobalLeft && pos.x < WaterBlockBehaviour.Instance.GlobalRight;
		}
		public static float GetWaterLevelOr(float fallback = -3.40282347E+38f)
		{
			if (!WaterBlockBehaviour.Instance)
			{
				return fallback;
			}
			return WaterBlockBehaviour.Instance.GlobalTop;
		}
		private void OnTriggerEnter2D(Collider2D collision)
		{
			this.DoSplash(collision);
		}
		private void OnTriggerExit2D(Collider2D collision)
		{
			this.DoSplash(collision);
		}
		private void DoSplash(Collider2D collision)
		{
			if (!UserPreferenceManager.Current.FancyEffects)
			{
				return;
			}
			if (collision.isTrigger)
			{
				return;
			}
			PhysicalBehaviour physicalBehaviour;
			if (!Global.main.PhysicalObjectsInWorldByTransform.TryGetValue(collision.transform, out physicalBehaviour))
			{
				return;
			}
			Rigidbody2D rigidbody = physicalBehaviour.rigidbody;
			GameObject gameObject = UnityEngine.Object.Instantiate<GameObject>(this.Splash, this.Trigger.bounds.ClosestPoint(collision.transform.position), Quaternion.identity);
			Vector2 velocity = rigidbody.velocity;
			gameObject.SetActive(true);
			velocity.y = -Mathf.Abs(velocity.y);
			gameObject.transform.up = Vector2.Reflect(velocity, Vector2.up);
			float num = Mathf.Min(collision.bounds.extents.x, 4f);
			float num2 = Mathf.Clamp(rigidbody.velocity.magnitude * 0.5f * rigidbody.mass, 0.2f, 25f);
			gameObject.GetComponent<AudioSource>().volume = num2 / 15f;
			foreach (ParticleSystem particleSystem in gameObject.GetComponentsInChildren<ParticleSystem>())
			{
				ParticleSystem.ShapeModule shape = particleSystem.shape;
				ParticleSystem.MainModule main = particleSystem.main;
				shape.radius = num;
				main.startSizeMultiplier = num * 2.5f * UnityEngine.Random.Range(1f, 1.4f);
				main.startSpeedMultiplier = num2;
			}
		}
		private void FixedUpdate()
		{
			Vector3 a = Vector3.up * this.Buoyancy;
			foreach (PhysicalBehaviour physicalBehaviour in Global.main.PhysicalObjectsInWorld)
			{
				if (!physicalBehaviour)
				{
					break;
				}
				if (physicalBehaviour.gameObject.layer == LayerMask.NameToLayer("Bounds"))
				{
					continue;
				}
				float num = Mathf.Clamp(Mathf.Pow(Mathf.Abs(physicalBehaviour.transform.position.y - this.GlobalTop), 0.25f), 1f, 8f);
				float d = Mathf.Clamp01((num - 1f) / 7f) + 1f;
				Vector2 force = a * physicalBehaviour.Properties.Buoyancy * physicalBehaviour.rigidbody.mass / (float)physicalBehaviour.LocalGridPointLength * num;
				bool flag = false;
				physicalBehaviour.CurrentWaterSurfaceLevel = this.GlobalTop;
				foreach (Vector2 v in physicalBehaviour.LocalColliderGridPoints)
				{
					Vector3 vector = physicalBehaviour.transform.TransformPoint(v);
					if (vector.y <= this.GlobalTop && vector.y >= this.GlobalBottom && vector.x <= this.GlobalRight && vector.x >= this.GlobalLeft)
					{
						flag = true;
						physicalBehaviour.rigidbody.AddForceAtPosition(force, vector);
						Vector2 pointVelocity = physicalBehaviour.rigidbody.GetPointVelocity(vector);
						physicalBehaviour.rigidbody.AddForceAtPosition(-pointVelocity * d * this.GetDragFactor(pointVelocity) * physicalBehaviour.rigidbody.mass * 0.4f, vector);
						///CUSTOMEFFECTS
					}
				}
				physicalBehaviour.IsUnderWater = flag;
				if (flag)
				{
					physicalBehaviour.Wetness += 0.1f;
					physicalBehaviour.SendMessage("WaterImpact", physicalBehaviour.rigidbody.velocity.magnitude, SendMessageOptions.DontRequireReceiver);
					physicalBehaviour.SendMessage("Suspended", SendMessageOptions.DontRequireReceiver);
				}
			}
		}
		private float GetDragFactor(Vector2 velocity)
		{
			float num = velocity.sqrMagnitude * 0.1f;
			return Mathf.Clamp(Mathf.Pow(num + 1f, num * this.Drag), 0.2f, 1f);
		}
		private void OnDrawGizmos()
		{
			Gizmos.color = Color.cyan;
			Gizmos.DrawLine(new Vector3(-99999f, this.GlobalTop), new Vector3(99999f, this.GlobalTop));
			Gizmos.DrawWireCube(this.WaterCenter, this.WaterSize);
		}
		public float Drag;
		public float Buoyancy;
		public float GlobalTop;
		public float GlobalBottom;
		public float GlobalLeft;
		public float GlobalRight;
		public Vector2 WaterCenter;
		public Vector2 WaterSize;
		public GameObject Splash;
		public Collider2D Trigger;
		public Collider2D[] insideWater = new Collider2D[1024];
		public LayerMask Layers;
		public static WaterBlockBehaviour Instance;
	}
}

